/**
 * <copyright>
 * </copyright>
 *
 * $Id: TableColumnImpl.java 7369 2011-03-18 09:54:34Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.openxma.dsl.core.model.BoolLiteral;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.PresentableFeature;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.ContentAlignment;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.FieldFeature;
import org.openxma.dsl.pom.model.LabelProperty;
import org.openxma.dsl.pom.model.StyleProperty;
import org.openxma.dsl.pom.model.TableColumn;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Table Column</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getObject <em>Object</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getFeature <em>Feature</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getColumnName <em>Column Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getVisible <em>Visible</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getLabel <em>Label</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getStyleProperty <em>Style Property</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getAlign <em>Align</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getWidth <em>Width</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#isRelativeWidth <em>Relative Width</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getMinWidth <em>Min Width</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.TableColumnImpl#getMaxWidth <em>Max Width</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TableColumnImpl extends MinimalEObjectImpl.Container implements TableColumn {
	/**
     * The cached value of the '{@link #getObject() <em>Object</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getObject()
     * @generated
     * @ordered
     */
	protected DataObjectVariable object;

	/**
     * The cached value of the '{@link #getFeature() <em>Feature</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getFeature()
     * @generated
     * @ordered
     */
	protected FieldFeature feature;

	/**
     * The default value of the '{@link #getColumnName() <em>Column Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getColumnName()
     * @generated
     * @ordered
     */
	protected static final String COLUMN_NAME_EDEFAULT = null;

	/**
     * The cached value of the '{@link #getColumnName() <em>Column Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getColumnName()
     * @generated
     * @ordered
     */
	protected String columnName = COLUMN_NAME_EDEFAULT;

	/**
     * The cached value of the '{@link #getVisible() <em>Visible</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getVisible()
     * @generated
     * @ordered
     */
	protected BoolLiteral visible;

	/**
     * The cached value of the '{@link #getLabel() <em>Label</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getLabel()
     * @generated
     * @ordered
     */
	protected LabelProperty label;

	/**
     * The cached value of the '{@link #getStyleProperty() <em>Style Property</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getStyleProperty()
     * @generated
     * @ordered
     */
    protected StyleProperty styleProperty;

    /**
     * The default value of the '{@link #getAlign() <em>Align</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getAlign()
     * @generated
     * @ordered
     */
	protected static final ContentAlignment ALIGN_EDEFAULT = ContentAlignment.DEFAULT;

	/**
     * The cached value of the '{@link #getAlign() <em>Align</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getAlign()
     * @generated
     * @ordered
     */
	protected ContentAlignment align = ALIGN_EDEFAULT;

	/**
     * The default value of the '{@link #getWidth() <em>Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getWidth()
     * @generated
     * @ordered
     */
	protected static final int WIDTH_EDEFAULT = 0;

	/**
     * The cached value of the '{@link #getWidth() <em>Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getWidth()
     * @generated
     * @ordered
     */
	protected int width = WIDTH_EDEFAULT;

	/**
     * The default value of the '{@link #isRelativeWidth() <em>Relative Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isRelativeWidth()
     * @generated
     * @ordered
     */
	protected static final boolean RELATIVE_WIDTH_EDEFAULT = false;

	/**
     * The cached value of the '{@link #isRelativeWidth() <em>Relative Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isRelativeWidth()
     * @generated
     * @ordered
     */
	protected boolean relativeWidth = RELATIVE_WIDTH_EDEFAULT;

	/**
     * The default value of the '{@link #getMinWidth() <em>Min Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMinWidth()
     * @generated
     * @ordered
     */
	protected static final int MIN_WIDTH_EDEFAULT = 0;

	/**
     * The cached value of the '{@link #getMinWidth() <em>Min Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMinWidth()
     * @generated
     * @ordered
     */
	protected int minWidth = MIN_WIDTH_EDEFAULT;

	/**
     * The default value of the '{@link #getMaxWidth() <em>Max Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMaxWidth()
     * @generated
     * @ordered
     */
	protected static final int MAX_WIDTH_EDEFAULT = 0;

	/**
     * The cached value of the '{@link #getMaxWidth() <em>Max Width</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getMaxWidth()
     * @generated
     * @ordered
     */
	protected int maxWidth = MAX_WIDTH_EDEFAULT;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected TableColumnImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return PomPackage.Literals.TABLE_COLUMN;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public DataObjectVariable getObject() {
        if (object != null && object.eIsProxy()) {
            InternalEObject oldObject = (InternalEObject)object;
            object = (DataObjectVariable)eResolveProxy(oldObject);
            if (object != oldObject) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.TABLE_COLUMN__OBJECT, oldObject, object));
            }
        }
        return object;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public DataObjectVariable basicGetObject() {
        return object;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setObject(DataObjectVariable newObject) {
        DataObjectVariable oldObject = object;
        object = newObject;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__OBJECT, oldObject, object));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public FieldFeature getFeature() {
        return feature;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetFeature(FieldFeature newFeature, NotificationChain msgs) {
        FieldFeature oldFeature = feature;
        feature = newFeature;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__FEATURE, oldFeature, newFeature);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setFeature(FieldFeature newFeature) {
        if (newFeature != feature) {
            NotificationChain msgs = null;
            if (feature != null)
                msgs = ((InternalEObject)feature).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__FEATURE, null, msgs);
            if (newFeature != null)
                msgs = ((InternalEObject)newFeature).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__FEATURE, null, msgs);
            msgs = basicSetFeature(newFeature, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__FEATURE, newFeature, newFeature));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getColumnName() {
        return columnName;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setColumnName(String newColumnName) {
        String oldColumnName = columnName;
        columnName = newColumnName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__COLUMN_NAME, oldColumnName, columnName));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public BoolLiteral getVisible() {
        return visible;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetVisible(BoolLiteral newVisible, NotificationChain msgs) {
        BoolLiteral oldVisible = visible;
        visible = newVisible;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__VISIBLE, oldVisible, newVisible);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setVisible(BoolLiteral newVisible) {
        if (newVisible != visible) {
            NotificationChain msgs = null;
            if (visible != null)
                msgs = ((InternalEObject)visible).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__VISIBLE, null, msgs);
            if (newVisible != null)
                msgs = ((InternalEObject)newVisible).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__VISIBLE, null, msgs);
            msgs = basicSetVisible(newVisible, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__VISIBLE, newVisible, newVisible));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public LabelProperty getLabel() {
        return label;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetLabel(LabelProperty newLabel, NotificationChain msgs) {
        LabelProperty oldLabel = label;
        label = newLabel;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__LABEL, oldLabel, newLabel);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setLabel(LabelProperty newLabel) {
        if (newLabel != label) {
            NotificationChain msgs = null;
            if (label != null)
                msgs = ((InternalEObject)label).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__LABEL, null, msgs);
            if (newLabel != null)
                msgs = ((InternalEObject)newLabel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__LABEL, null, msgs);
            msgs = basicSetLabel(newLabel, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__LABEL, newLabel, newLabel));
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public StyleProperty getStyleProperty() {
        return styleProperty;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetStyleProperty(StyleProperty newStyleProperty, NotificationChain msgs) {
        StyleProperty oldStyleProperty = styleProperty;
        styleProperty = newStyleProperty;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__STYLE_PROPERTY, oldStyleProperty, newStyleProperty);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setStyleProperty(StyleProperty newStyleProperty) {
        if (newStyleProperty != styleProperty) {
            NotificationChain msgs = null;
            if (styleProperty != null)
                msgs = ((InternalEObject)styleProperty).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__STYLE_PROPERTY, null, msgs);
            if (newStyleProperty != null)
                msgs = ((InternalEObject)newStyleProperty).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.TABLE_COLUMN__STYLE_PROPERTY, null, msgs);
            msgs = basicSetStyleProperty(newStyleProperty, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__STYLE_PROPERTY, newStyleProperty, newStyleProperty));
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ContentAlignment getAlign() {
        return align;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setAlign(ContentAlignment newAlign) {
        ContentAlignment oldAlign = align;
        align = newAlign == null ? ALIGN_EDEFAULT : newAlign;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__ALIGN, oldAlign, align));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getWidth() {
        return width;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setWidth(int newWidth) {
        int oldWidth = width;
        width = newWidth;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__WIDTH, oldWidth, width));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean isRelativeWidth() {
        return relativeWidth;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setRelativeWidth(boolean newRelativeWidth) {
        boolean oldRelativeWidth = relativeWidth;
        relativeWidth = newRelativeWidth;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__RELATIVE_WIDTH, oldRelativeWidth, relativeWidth));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getMinWidth() {
        return minWidth;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setMinWidth(int newMinWidth) {
        int oldMinWidth = minWidth;
        minWidth = newMinWidth;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__MIN_WIDTH, oldMinWidth, minWidth));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getMaxWidth() {
        return maxWidth;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setMaxWidth(int newMaxWidth) {
        int oldMaxWidth = maxWidth;
        maxWidth = newMaxWidth;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.TABLE_COLUMN__MAX_WIDTH, oldMaxWidth, maxWidth));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case PomPackage.TABLE_COLUMN__FEATURE:
                return basicSetFeature(null, msgs);
            case PomPackage.TABLE_COLUMN__VISIBLE:
                return basicSetVisible(null, msgs);
            case PomPackage.TABLE_COLUMN__LABEL:
                return basicSetLabel(null, msgs);
            case PomPackage.TABLE_COLUMN__STYLE_PROPERTY:
                return basicSetStyleProperty(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case PomPackage.TABLE_COLUMN__OBJECT:
                if (resolve) return getObject();
                return basicGetObject();
            case PomPackage.TABLE_COLUMN__FEATURE:
                return getFeature();
            case PomPackage.TABLE_COLUMN__COLUMN_NAME:
                return getColumnName();
            case PomPackage.TABLE_COLUMN__VISIBLE:
                return getVisible();
            case PomPackage.TABLE_COLUMN__LABEL:
                return getLabel();
            case PomPackage.TABLE_COLUMN__STYLE_PROPERTY:
                return getStyleProperty();
            case PomPackage.TABLE_COLUMN__ALIGN:
                return getAlign();
            case PomPackage.TABLE_COLUMN__WIDTH:
                return getWidth();
            case PomPackage.TABLE_COLUMN__RELATIVE_WIDTH:
                return isRelativeWidth();
            case PomPackage.TABLE_COLUMN__MIN_WIDTH:
                return getMinWidth();
            case PomPackage.TABLE_COLUMN__MAX_WIDTH:
                return getMaxWidth();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case PomPackage.TABLE_COLUMN__OBJECT:
                setObject((DataObjectVariable)newValue);
                return;
            case PomPackage.TABLE_COLUMN__FEATURE:
                setFeature((FieldFeature)newValue);
                return;
            case PomPackage.TABLE_COLUMN__COLUMN_NAME:
                setColumnName((String)newValue);
                return;
            case PomPackage.TABLE_COLUMN__VISIBLE:
                setVisible((BoolLiteral)newValue);
                return;
            case PomPackage.TABLE_COLUMN__LABEL:
                setLabel((LabelProperty)newValue);
                return;
            case PomPackage.TABLE_COLUMN__STYLE_PROPERTY:
                setStyleProperty((StyleProperty)newValue);
                return;
            case PomPackage.TABLE_COLUMN__ALIGN:
                setAlign((ContentAlignment)newValue);
                return;
            case PomPackage.TABLE_COLUMN__WIDTH:
                setWidth((Integer)newValue);
                return;
            case PomPackage.TABLE_COLUMN__RELATIVE_WIDTH:
                setRelativeWidth((Boolean)newValue);
                return;
            case PomPackage.TABLE_COLUMN__MIN_WIDTH:
                setMinWidth((Integer)newValue);
                return;
            case PomPackage.TABLE_COLUMN__MAX_WIDTH:
                setMaxWidth((Integer)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case PomPackage.TABLE_COLUMN__OBJECT:
                setObject((DataObjectVariable)null);
                return;
            case PomPackage.TABLE_COLUMN__FEATURE:
                setFeature((FieldFeature)null);
                return;
            case PomPackage.TABLE_COLUMN__COLUMN_NAME:
                setColumnName(COLUMN_NAME_EDEFAULT);
                return;
            case PomPackage.TABLE_COLUMN__VISIBLE:
                setVisible((BoolLiteral)null);
                return;
            case PomPackage.TABLE_COLUMN__LABEL:
                setLabel((LabelProperty)null);
                return;
            case PomPackage.TABLE_COLUMN__STYLE_PROPERTY:
                setStyleProperty((StyleProperty)null);
                return;
            case PomPackage.TABLE_COLUMN__ALIGN:
                setAlign(ALIGN_EDEFAULT);
                return;
            case PomPackage.TABLE_COLUMN__WIDTH:
                setWidth(WIDTH_EDEFAULT);
                return;
            case PomPackage.TABLE_COLUMN__RELATIVE_WIDTH:
                setRelativeWidth(RELATIVE_WIDTH_EDEFAULT);
                return;
            case PomPackage.TABLE_COLUMN__MIN_WIDTH:
                setMinWidth(MIN_WIDTH_EDEFAULT);
                return;
            case PomPackage.TABLE_COLUMN__MAX_WIDTH:
                setMaxWidth(MAX_WIDTH_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case PomPackage.TABLE_COLUMN__OBJECT:
                return object != null;
            case PomPackage.TABLE_COLUMN__FEATURE:
                return feature != null;
            case PomPackage.TABLE_COLUMN__COLUMN_NAME:
                return COLUMN_NAME_EDEFAULT == null ? columnName != null : !COLUMN_NAME_EDEFAULT.equals(columnName);
            case PomPackage.TABLE_COLUMN__VISIBLE:
                return visible != null;
            case PomPackage.TABLE_COLUMN__LABEL:
                return label != null;
            case PomPackage.TABLE_COLUMN__STYLE_PROPERTY:
                return styleProperty != null;
            case PomPackage.TABLE_COLUMN__ALIGN:
                return align != ALIGN_EDEFAULT;
            case PomPackage.TABLE_COLUMN__WIDTH:
                return width != WIDTH_EDEFAULT;
            case PomPackage.TABLE_COLUMN__RELATIVE_WIDTH:
                return relativeWidth != RELATIVE_WIDTH_EDEFAULT;
            case PomPackage.TABLE_COLUMN__MIN_WIDTH:
                return minWidth != MIN_WIDTH_EDEFAULT;
            case PomPackage.TABLE_COLUMN__MAX_WIDTH:
                return maxWidth != MAX_WIDTH_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (columnName: ");
        result.append(columnName);
        result.append(", align: ");
        result.append(align);
        result.append(", width: ");
        result.append(width);
        result.append(", relativeWidth: ");
        result.append(relativeWidth);
        result.append(", minWidth: ");
        result.append(minWidth);
        result.append(", maxWidth: ");
        result.append(maxWidth);
        result.append(')');
        return result.toString();
    }
	
	/**
     * @modified
     * @return the AttributeHolder
     */	
	public PresentableFeature getAttributeHolder() {		
		if (getFeature() != null) {
			return getFeature().getAttributeHolder();
		}
		return null;
	}			
	
    /**
     * @modified
     * @return the unit text for the field
     */
    public Attribute getAttribute() {
    	PresentableFeature attributeHolder = getAttributeHolder();    	
    	if (attributeHolder != null) {
    		return attributeHolder.getAttribute();
    	}
    	return null;
    }
    
	/**
     * @modified
     * @return the label text for the field
     */
    public String getLabelText() {
    	String labelText = null;
    	if (label != null) {
    		labelText = label.getText();
    	}
    	// Get default label text from attribute
    	if (labelText == null) {
    		PresentableFeature attributeHolder = getAttributeHolder();
    		if (attributeHolder != null) {
				labelText = attributeHolder.getLabelText();
		    	// Derive label text from attribute name
				if (labelText == null) {
					String preFix = (getObject() != null) ? getObject().getName()+"." : "";
					labelText = preFix+getAttributeHolder().getCalculatedName();
				}  				
			}    		    		
    	}  	
		return labelText;    	
    }

} //TableColumnImpl
