lexer grammar InternalPomDsl;
@header {
package org.openxma.dsl.pom.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;
}

T15 : 'namespace' ;
T16 : '-' ;
T17 : '*' ;
T18 : 'enabled' ;
T19 : '=' ;
T20 : 'mandatory' ;
T21 : 'visible' ;
T22 : 'collapsed' ;
T23 : 'available' ;
T24 : 'editable' ;
T25 : 'tabable' ;
T26 : 'label' ;
T27 : 'public' ;
T28 : 'property' ;
T29 : 'readonly' ;
T30 : 'required' ;
T31 : 'component' ;
T32 : 'xma' ;
T33 : '::' ;
T34 : 'defaultpage' ;
T35 : 'uses' ;
T36 : ',' ;
T37 : '{' ;
T38 : '}' ;
T39 : 'page' ;
T40 : 'content' ;
T41 : 'panel' ;
T42 : 'hpanel' ;
T43 : 'vpanel' ;
T44 : 'graylogic' ;
T45 : 'data' ;
T46 : '[]' ;
T47 : 'customize' ;
T48 : 'constraints' ;
T49 : 'format' ;
T50 : 'flags=' ;
T51 : 'tooltip' ;
T52 : 'unit' ;
T53 : '.' ;
T54 : '(' ;
T55 : ')' ;
T56 : '[' ;
T57 : ']' ;
T58 : 'multiline' ;
T59 : 'command' ;
T60 : 'uicommand' ;
T61 : ':' ;
T62 : 'eventmapping' ;
T63 : '->' ;
T64 : 'onInit' ;
T65 : 'onEnter' ;
T66 : 'onLeave' ;
T67 : 'databinding' ;
T68 : '<->' ;
T69 : 'abstract' ;
T70 : 'extends' ;
T71 : 'extend' ;
T72 : 'logic' ;
T73 : 'case' ;
T74 : 'default' ;
T75 : 'columns' ;
T76 : 'taborder' ;
T77 : 'width' ;
T78 : 'text' ;
T79 : 'align' ;
T80 : 'combo' ;
T81 : 'checkbox' ;
T82 : 'listbox' ;
T83 : 'ipanel' ;
T84 : 'tree' ;
T85 : 'radiobutton' ;
T86 : 'seperator' ;
T87 : 'orientation' ;
T88 : 'image' ;
T89 : 'uri' ;
T90 : 'button' ;
T91 : 'scrollable' ;
T92 : 'splitpanel' ;
T93 : 'splitposition' ;
T94 : 'composite' ;
T95 : 'table' ;
T96 : 'key' ;
T97 : 'columnMinWidth' ;
T98 : 'multiselection' ;
T99 : 'oneway' ;
T100 : 'gridvisible' ;
T101 : 'sortindicator' ;
T102 : 'pageable' ;
T103 : 'filterable' ;
T104 : 'checkselection' ;
T105 : 'column' ;
T106 : 'minWidth=' ;
T107 : 'maxWidth=' ;
T108 : 'tabfolder' ;
T109 : 'tabpage' ;
T110 : 'height' ;
T111 : 'char' ;
T112 : '+' ;
T113 : 'style' ;
T114 : 'modality' ;
T115 : 'titlebuttons' ;
T116 : 'none' ;
T117 : 'resizeable' ;
T118 : 'true' ;
T119 : 'false' ;
T120 : 'tabulator' ;
T121 : '<' ;
T122 : '>' ;
T123 : 'cellwidths' ;
T124 : 'cellheights' ;
T125 : 'spacing' ;
T126 : 'margin' ;
T127 : 'string' ;
T128 : 'integer' ;
T129 : 'imageuri' ;
T130 : 'definitions' ;
T131 : 'auto' ;
T132 : 'stretch' ;
T133 : 'attachmentposition' ;
T134 : '%' ;
T135 : 'cell' ;
T136 : '|' ;
T137 : '&' ;
T138 : 'div' ;
T139 : 'tab' ;
T140 : 'select' ;
T141 : '#' ;
T142 : 'field-parts' ;
T143 : 'left' ;
T144 : 'right' ;
T145 : 'top' ;
T146 : 'bottom' ;
T147 : 'border-style' ;
T148 : 'solid' ;
T149 : 'foreground-color' ;
T150 : 'rgb' ;
T151 : 'background-color' ;
T152 : 'widget-variant' ;
T153 : 'font' ;
T154 : 'character-width' ;
T155 : 'line-wrap' ;
T156 : 'multi-line' ;
T157 : 'browse-control' ;
T158 : 'paging-style' ;
T159 : 'paging-controls' ;
T160 : 'paging-page-size' ;
T161 : 'max' ;
T162 : 'paging-jump-size' ;
T163 : 'paging-position' ;
T164 : 'paging-customizer-image' ;
T165 : 'end' ;
T166 : 'next' ;
T167 : 'table-customizer' ;
T168 : 'enumeration-displaytype' ;
T169 : 'enumeration-sortorder' ;
T170 : 'dynamic-tabpage' ;
T171 : 'thousand-seperator' ;
T172 : 'tablecustomizer' ;
T173 : 'instancetype' ;
T174 : 'if' ;
T175 : 'then' ;
T176 : 'else' ;
T177 : 'invoke' ;
T178 : 'return' ;
T179 : 'proxy' ;
T180 : 'service' ;
T181 : 'operation' ;
T182 : 'as' ;
T183 : 'filter' ;
T184 : 'valueobject' ;
T185 : 'dataview' ;
T186 : 'all' ;
T187 : '.*' ;
T188 : '<-' ;
T189 : 'entity' ;
T190 : 'id' ;
T191 : 'version' ;
T192 : 'composition' ;
T193 : 'oppositeof' ;
T194 : 'orderby' ;
T195 : 'derived' ;
T196 : 'transient' ;
T197 : 'title' ;
T198 : 'description' ;
T199 : 'unique' ;
T200 : 'sortorder' ;
T201 : 'asc' ;
T202 : 'desc' ;
T203 : 'repository' ;
T204 : 'for' ;
T205 : 'discriminator' ;
T206 : 'qualifier' ;
T207 : 'usertype' ;
T208 : 'sqltype' ;
T209 : 'many-to-one' ;
T210 : 'one-to-one' ;
T211 : 'one-to-many' ;
T212 : 'many-to-many' ;
T213 : 'conditions' ;
T214 : 'function' ;
T215 : 'call' ;
T216 : 'insert' ;
T217 : 'into' ;
T218 : 'delete' ;
T219 : 'from' ;
T220 : 'where' ;
T221 : 'update' ;
T222 : 'versioned' ;
T223 : 'set' ;
T224 : 'group' ;
T225 : 'by' ;
T226 : 'having' ;
T227 : 'order' ;
T228 : 'distinct' ;
T229 : 'new' ;
T230 : 'object' ;
T231 : 'in' ;
T232 : 'class' ;
T233 : 'elements' ;
T234 : 'join' ;
T235 : 'fetch' ;
T236 : 'with' ;
T237 : 'or' ;
T238 : 'and' ;
T239 : 'not' ;
T240 : 'is' ;
T241 : '!=' ;
T242 : '<>' ;
T243 : '<=' ;
T244 : '>=' ;
T245 : 'between' ;
T246 : 'like' ;
T247 : 'escape' ;
T248 : 'member' ;
T249 : 'of' ;
T250 : '||' ;
T251 : '/' ;
T252 : 'trim' ;
T253 : 'trailing' ;
T254 : 'leading' ;
T255 : 'both' ;
T256 : 'cast' ;
T257 : 'extract' ;
T258 : 'sum' ;
T259 : 'avg' ;
T260 : 'min' ;
T261 : 'count' ;
T262 : 'some' ;
T263 : 'exists' ;
T264 : 'any' ;
T265 : 'when' ;
T266 : 'indices' ;
T267 : 'union' ;
T268 : 'null' ;
T269 : 'empty' ;
T270 : 'properties' ;
T271 : 'outer' ;
T272 : 'full' ;
T273 : 'inner' ;
T274 : 'import' ;
T275 : 'enum' ;
T276 : 'validation' ;
T277 : 'redefines' ;
T278 : '...' ;
T279 : 'doc:' ;
T280 : 'onClick' ;
T281 : 'onDoubleClick' ;
T282 : 'onSelection' ;
T283 : 'onDefaultSelection' ;
T284 : 'onExpand' ;
T285 : 'onCollapse' ;
T286 : 'onLoad' ;
T287 : 'closeOK' ;
T288 : 'closeCancel' ;
T289 : 'vcenter' ;
T290 : 'hcenter' ;
T291 : 'previous' ;
T292 : 'prev' ;
T293 : 'center' ;
T294 : 'horizontal' ;
T295 : 'vertical' ;
T296 : 'control' ;
T297 : 'unitLabel' ;
T298 : 'editor' ;
T299 : 'minimize' ;
T300 : 'maximize' ;
T301 : 'close' ;
T302 : 'field' ;
T303 : 'datepicker' ;
T304 : 'create' ;
T305 : 'read' ;
T306 : 'crud' ;
T307 : 'index' ;
T308 : 'natural' ;
T309 : 'primary' ;
T310 : 'boolean' ;
T311 : '==' ;
T312 : 'getValue()' ;
T313 : 'hasValue()' ;
T314 : 'getSelectedValue()' ;
T315 : 'isSelected()' ;
T316 : 'getSelectionCount()' ;
T317 : 'size()' ;
T318 : 'isValid()' ;
T319 : 'number' ;
T320 : 'date' ;
T321 : 'timestamp' ;
T322 : 'enumeration' ;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36546
RULE_EXP_INT : RULE_INT ('e'|'E') ('-'|'+') RULE_INT;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36548
RULE_HEX : '0' ('x'|'X') ('0'..'9'|'a'..'f'|'A'..'F')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36550
RULE_REGION_START : '#region' ~(('\n'|'\r'))* ('\r'? '\n')?;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36552
RULE_REGION_END : '#endregion';

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36554
RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36556
RULE_INT : ('0'..'9')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36558
RULE_STRING : ('"' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'"')))* '"'|'\'' ('\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\')|~(('\\'|'\'')))* '\'');

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36560
RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36562
RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36564
RULE_WS : (' '|'\t'|'\r'|'\n')+;

// $ANTLR src "../org.openxma.dsl.pom/src-gen/org/openxma/dsl/pom/parser/antlr/internal/InternalPomDsl.g" 36566
RULE_ANY_OTHER : .;


